﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using TMPro;
using Saltosion.OneWeapon.Player;
using Saltosion.OneWeapon.Guns;

namespace Saltosion.OneWeapon.GUI {
    public class HUDController : MonoBehaviour {


        [Header("General")]
        public PlayerController Player;
        public PlayerFun PlayerFun;
        public RawImage FunMeter;
        public Image GunImage;

        [Header("Gore Texts")]
        public TMP_Text DamageTextGore;
        public TMP_Text FunTextGore;
        public TMP_Text GunTextGore;

        [Header("Fun Texts")]
        public TMP_Text DamageTextFun;
        public TMP_Text FunTextFun;
        public TMP_Text GunTextFun;

        private string[] GoreTexts = new string[] { "I'm gonna die of boredom!", "Ultra lame!", "Oof, boring!", "That's cool!", "Holy fuck!", "Bloody awesome!" };
        private string[] FunTexts = new string[] { "I'm gonna fall asleep!", "You should try doing something!", "There aren't enough flowers", "Now that's pretty!", "You're doing great!", "Faboulous!" };

        private Gun LastGun;

        void Start() {
            GunTextGore.text = "";
            GunTextFun.text = "";
        }

        void Update() {
            float FunPercent = (PlayerFun.CurrentFun / PlayerFun.MaxFun);
            Vector3 Scale = FunMeter.transform.localScale;

            Scale.x = FunPercent;
            FunMeter.transform.localScale = Scale;
            Rect UVRect = FunMeter.uvRect;
            UVRect.width = FunPercent;
            FunMeter.uvRect = UVRect;

            float FunLevel = Mathf.Floor(FunPercent * 6) / 6;

            Color Color = FunMeter.color;
            Color.g = FunLevel;
            Color.r = 1 - FunLevel;
            FunMeter.color = Color;

            int FunPercentNumber = (int)Mathf.Round(PlayerFun.CurrentDamageBoost * 100);
            string Text = "+" + FunPercentNumber + "%";
            DamageTextGore.text = Text;
            DamageTextFun.text = Text;

            Color GoreColor = DamageTextGore.color;
            GoreColor.g = 1 - PlayerFun.CurrentDamageBoost;
            GoreColor.b = 1 - PlayerFun.CurrentDamageBoost;
            DamageTextGore.color = GoreColor;
            FunTextGore.color = GoreColor;

            Color FunColor = DamageTextFun.color;
            FunColor.b = 1 - PlayerFun.CurrentDamageBoost;
            DamageTextFun.color = FunColor;
            FunTextFun.color = FunColor;

            int FunLevelInt = (int)Mathf.Clamp(Mathf.Floor(FunPercent * 6), 0, 5);
            FunTextGore.text = GoreTexts[FunLevelInt];
            FunTextFun.text = FunTexts[FunLevelInt];

            if (Player.Gun != LastGun) {
                LastGun = Player.Gun;
                if (LastGun == null) {
                    GunTextGore.text = "";
                    GunTextFun.text = "";
                    GunImage.color = new Color(0, 0, 0, 0);
                } else {
                    GunTextGore.text = LastGun.Name;
                    GunTextFun.text = LastGun.Name;
                    GunImage.sprite = LastGun.GunSprite;
                    GunImage.color = new Color(1, 1, 1, 1);
                }
            }
        }
    }
}
